//
local debug = 0

local function sp()
	if multiplayer then return false end
	if marathonmode then return false end
	if modeattacking then return false end
	if ultimatemode then return false end
	return true
end

addHook("PlayerThink", function(p)
	if not p and p.valid and p.mo and p.mo.valid then return end
	if GlobalBanks_Array == nil then return end
	if debug > 1 then P_AddPlayerScore(p, 5000) end
	if p.fakedisplives == nil then
		if sp() and (GlobalBanks_Array[2] >> 16) != 0 then
			p.fakedisplives = (GlobalBanks_Array[2] >> 16)
			if debug then
				print("loaded succ")
			end
		else
			p.fakedisplives = p.lives
			local upperbit = (GlobalBanks_Array[2] >> 16)
			local lowerbit = (GlobalBanks_Array[2] % FRACUNIT)
			if (GlobalBanks_Array[2] >> 16) != p.fakedisplives then
				GlobalBanks_Array[2] = (p.fakedisplives<<16) + lowerbit
			end
			if debug then
				print("loaded unsucc")
			end
		end
	end
	if p.lives > 94 and p.lives != INFLIVES then
		p.lives = $ - 1
		if p.fakedisplives < 9999 then
			p.fakedisplives = $ + 1
			if sp() then
				local upperbit = GlobalBanks_Array[2] >> 16
				local lowerbit = (GlobalBanks_Array[2] % FRACUNIT)
				GlobalBanks_Array[2] = (p.fakedisplives<<16) + lowerbit
			end
		else
			P_GivePlayerRings(p, 100)
		end
	end
	if p.fakedisplives > 94 and (p.lives <= 93 and p.lives >= 60) then
		p.fakedisplives = $ - 1
		p.lives = $ + 1
		if sp() then
			local upperbit = (GlobalBanks_Array[2] >> 16)
			local lowerbit = (GlobalBanks_Array[2] % FRACUNIT)
			GlobalBanks_Array[2] = (p.fakedisplives<<16) + lowerbit
		end
	end	
	
	if p.skipscrap != nil then
		p.fakedispsavedscrap = p.skipscrap
	else
		p.fakedispsavedscrap = -1
	end

end)

local function DrawLivesIcons(v, p, cam)
	if not p.realmo then return end
	if ultimatemode
	or p.lives == INFLIVES 
	or p.mrce and p.mrce.hud then return end
	if (hud.enabled("lives")) then
		hud.disable("lives")
	end
	
	local soop = false
	if p.powers[pw_super] then soop = true end
	
	local moveit = 0
	if p.fakedisplives > 99 and p.fakedisplives < 1000 then moveit = 5
	elseif p.fakedisplives > 999 then moveit = 10 end
	
	local lifesprite = v.getSprite2Patch(p.realmo.skin, SPR2_XTRA, soop, A)
	
	v.drawScaled(16*FRACUNIT, 176*FRACUNIT, FRACUNIT/2, v.cachePatch("stlivebk"), V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(p.realmo.skin, p.realmo.color))
	v.drawScaled(16*FRACUNIT, 176*FRACUNIT, FRACUNIT/2, lifesprite, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(p.realmo.skin, p.realmo.color))
	v.drawScaled(38*FRACUNIT, 176*FRACUNIT + (9*FRACUNIT), FRACUNIT, v.cachePatch("stlivex"), V_SNAPTOLEFT|V_SNAPTOBOTTOM) 
	v.drawString(34, 176, skins[p.realmo.skin].hudname, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_YELLOWMAP)
	v.drawString(58 - moveit, 184, p.fakedisplives, V_SNAPTOLEFT|V_SNAPTOBOTTOM)
end

hud.add(DrawLivesIcons, "game")

addHook("PlayerSpawn", function(p)
	local upperbit = (GlobalBanks_Array[2] >> 16)
	local lowerbit = (GlobalBanks_Array[2] % FRACUNIT)

	if p.fakedispdeathcounter == nil then
		if sp() and lowerbit != 0 then
			p.fakedispdeathcounter = lowerbit
		else
			p.fakedispdeathcounter = 0
		end
	end

	if p.fakedispdead == nil then p.fakedispdead = true end --if first mapload of session, value won't be valid yet, so initialize it

	if p.fakedispmap == nil then p.fakedispmap = gamemap end

	if p.fakedispmap != gamemap then
		p.fakedispmap = gamemap
		p.fakedispdead = true
	end
	
	if not p.fakedispdead and not G_IsSpecialStage(gamemap) then -- also thx mmt for how tf I was gonna figure out if the player paused and hit retry
		p.fakedispdeathcounter = $ + 1
		if sp() then
			GlobalBanks_Array[2] = (upperbit<<16) + p.fakedispdeathcounter
		end
	else
		p.fakedispdead = false
	end
end)

addHook("PlayerThink", function(p)	
	--if not G_GametypeUsesLives() then return end
	if not p.fakedispmap then return end
	local upperbit = (GlobalBanks_Array[2] >> 16)
	local lowerbit = (GlobalBanks_Array[2] % FRACUNIT)
	if p.fakedispjustdied == nil then p.fakedispjustdied = false end
	if p.playerstate == PST_DEAD and p.fakedispjustdied == false then
		p.fakedispdeathcounter = $ + 1
		GlobalBanks_Array[2] = (upperbit<<16) + p.fakedispdeathcounter
		p.fakedispjustdied = true
		p.fakedispdead = true
	end
end)

local function DrawDeathCounter(v)
	local p = displayplayer
	local num = 0
	if (p.mrce and p.mrce.hud ==1) then
		num = 30
	else
		num = 0
	end
	v.drawString(16 + num, 166, "\133DEATHS: \143" .. p.fakedispdeathcounter, V_SNAPTOLEFT|V_SNAPTOBOTTOM)
end

hud.add(DrawDeathCounter, "scores")